commit 499af4e899d82c2a3392af2c4d4ce4947a8f0b22
Author: Jan Pašek <janpasek97@gmail.com>
Date:   Mon Mar 29 14:42:58 2021 +0200

    Re #8474 - Styling of create_certificate.html using Bootstrap

diff --git a/static/create_certificate.html b/static/create_certificate.html
index 62c5084..ce6a10a 100644
--- a/static/create_certificate.html
+++ b/static/create_certificate.html
@@ -3,103 +3,138 @@
 <head>
     <meta charset="UTF-8">
     <title>X.509 Certificate Management</title>
+    <link rel="stylesheet" href="/static/css/bootstrap.min.css">
 </head>
-<body>
-    <h1>Create certificate</h1>
+<body class="p-4">
+    <h1>Create Certificate</h1>
 
     <table>
         <tr>
-            <td><label for="CA">Choose a car:</label></td>
-            <td>
-                <select name="CA" id="CA">
-                    <option value="volvo">Self-Signed</option>
-                    <option value="#test-cert-id">Test</option>
-                </select>
-            </td>
+            <div class="form-group">
+                <td><label for="CA">Choose a car:</label></td>
+                <td>
+                    <select name="CA" id="CA" class="form-control">
+                        <option value="volvo">Self-Signed</option>
+                        <option value="#test-cert-id">Test</option>
+                    </select>
+                </td>
+            </div>
         </tr>
         <tr>
-            <td><label for="validity_start">Validity start:</label></td>
-            <td><input type="date" id="validity_start" name="validity_start"></td>
+            <div class="form-group">
+                <td><label for="validity_start">Validity start:</label></td>
+                <td><input type="date" id="validity_start" name="validity_start" class="form-control"></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="validity_end">Validity end:</label></td>
-            <td><input type="date" id="validity_end" name="validity_end"></td>
+            <div class="form-group">
+                <td><label for="validity_end">Validity end:</label></td>
+                <td><input type="date" id="validity_end" name="validity_end" class="form-control"></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="issuer_CN">Common Name:</label></td>
-            <td><input type="text" id="issuer_CN" name="issuer_CN" disabled></td>
+            <div class="form-group">
+                <td><label for="issuer_CN">Common Name:</label></td>
+                <td><input type="text" id="issuer_CN" name="issuer_CN" class="form-control" disabled></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="issuer_C">Country Code:</label></td>
-            <td><input type="text" id="issuer_C" name="issuer_C" disabled></td>
+            <div class="form-group">
+                <td><label for="issuer_C">Country Code:</label></td>
+                <td><input type="text" id="issuer_C" name="issuer_C" class="form-control" disabled></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="issuer_L">Locality:</label></td>
-            <td><input type="text" id="issuer_L" name="issuer_L" disabled></td>
+            <div class="form-group">
+                <td><label for="issuer_L">Locality:</label></td>
+                <td><input type="text" id="issuer_L" name="issuer_L" class="form-control" disabled></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="issuer_ST">Province/State:</label></td>
-            <td><input type="text" id="issuer_ST" name="issuer_ST" disabled></td>
+            <div class="form-group">
+                <td><label for="issuer_ST">Province/State:</label></td>
+                <td><input type="text" id="issuer_ST" name="issuer_ST" class="form-control" disabled></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="issuer_O">Organization:</label></td>
-            <td><input type="text" id="issuer_O" name="issuer_O" disabled></td>
+            <div class="form-group">
+                <td><label for="issuer_O">Organization:</label></td>
+                <td><input type="text" id="issuer_O" name="issuer_O" class="form-control" disabled></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="issuer_OU">Organization Unit:</label></td>
-            <td><input type="text" id="issuer_OU" name="issuer_OU" disabled></td>
+            <div class="form-group">
+                <td><label for="issuer_OU">Organization Unit:</label></td>
+                <td><input type="text" id="issuer_OU" name="issuer_OU" class="form-control" disabled></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="issuer_emailAddress">Email:</label></td>
-            <td><input type="email" id="issuer_emailAddress" name="issuer_emailAddress" disabled></td>
+            <div class="form-group">
+                <td><label for="issuer_emailAddress">Email:</label></td>
+                <td><input type="email" id="issuer_emailAddress" name="issuer_emailAddress" class="form-control" disabled></td>
+            </div>
         </tr>
-                <tr>
-            <td><label for="subject_CN">Common Name:</label></td>
-            <td><input type="text" id="subject_CN" name="subject_CN"></td>
+        <tr>
+            <div class="form-group">
+                <td><label for="subject_CN">Common Name:</label></td>
+                <td><input type="text" id="subject_CN" name="subject_CN" class="form-control"></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="subject_C">Country Code:</label></td>
-            <td><input type="text" id="subject_C" name="subject_C"></td>
+            <div class="form-group">
+                <td><label for="subject_C">Country Code:</label></td>
+                <td><input type="text" id="subject_C" name="subject_C" class="form-control"></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="subject_L">Locality:</label></td>
-            <td><input type="text" id="subject_L" name="subject_L"></td>
+            <div class="form-group">
+                <td><label for="subject_L">Locality:</label></td>
+                <td><input type="text" id="subject_L" name="subject_L" class="form-control"></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="subject_ST">Province/State:</label></td>
-            <td><input type="text" id="subject_ST" name="subject_ST"></td>
+            <div class="form-group">
+                <td><label for="subject_ST">Province/State:</label></td>
+                <td><input type="text" id="subject_ST" name="subject_ST" class="form-control"></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="subject_O">Organization:</label></td>
-            <td><input type="text" id="subject_O" name="subject_O"></td>
+            <div class="form-group">
+                <td><label for="subject_O">Organization:</label></td>
+                <td><input type="text" id="subject_O" name="subject_O" class="form-control"></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="subject_OU">Organization Unit:</label></td>
-            <td><input type="text" id="subject_OU" name="subject_OU"></td>
+            <div class="form-group">
+                <td><label for="subject_OU">Organization Unit:</label></td>
+                <td><input type="text" id="subject_OU" name="subject_OU" class="form-control"></td>
+            </div>
         </tr>
         <tr>
-            <td><label for="subject_emailAddress">Email:</label></td>
-            <td><input type="email" id="subject_emailAddress" name="subject_emailAddress"></td>
+            <div class="form-group">
+                <td><label for="subject_emailAddress">Email:</label></td>
+                <td><input type="email" id="subject_emailAddress" name="subject_emailAddress" class="form-control"></td>
+            </div>
         </tr>
         <tr>
             <td>Usage:</td>
-            <td>
-                <input type="checkbox" id="isCA" name="isCA" value="CA">
-                <label for="isCA">CA</label><br>
+            <td class="form-check">
+                <input class="form-check-input" type="checkbox" id="isCA" name="isCA" value="CA">
+                <label class="form-check-label" for="isCA">CA</label><br>
 
-                <input type="checkbox" id="isDigitalSignature" name="isDigitalSignature" value="DigitalSignature">
-                <label for="isDigitalSignature">Digital Signature</label><br>
+                <input class="form-check-input" type="checkbox" id="isDigitalSignature" name="isDigitalSignature" value="DigitalSignature">
+                <label class="form-check-label" for="isDigitalSignature">Digital Signature</label><br>
 
-                <input type="checkbox" id="isAuthentication" name="isAuthentication" value="Authentication">
-                <label for="isAuthentication">Authentication</label><br>
+                <input class="form-check-input" type="checkbox" id="isAuthentication" name="isAuthentication" value="Authentication">
+                <label class="form-check-label" for="isAuthentication">Authentication</label><br>
 
-                <input type="checkbox" id="isSSL_TLS" name="isSSL_TLS" value="SSL_TLS">
-                <label for="isSSL_TLS">SSL/TLS</label><br>
+                <input class="form-check-input" type="checkbox" id="isSSL_TLS" name="isSSL_TLS" value="SSL_TLS">
+                <label class="form-check-label" for="isSSL_TLS">SSL/TLS</label><br>
             </td>
         </tr>
         <tr>
             <td colspan="2" align="center">
-                <button onclick="window.location.href = '/static/index.html';">Create certificate</button>
+                <button class="btn btn-success" onclick="window.location.href = '/static/index.html';">Create certificate</button>
             </td>
         </tr>
     </table>
diff --git a/static/index.html b/static/index.html
index 34e3ca7..af0f8e3 100644
--- a/static/index.html
+++ b/static/index.html
@@ -5,7 +5,7 @@
     <title>X.509 Certificate Management</title>
     <link rel="stylesheet" href="/static/css/bootstrap.min.css">
 </head>
-<body>
+<body class="p-4">
     <div>
         <h1 class="ml-2 d-inline-block">Certificate Listing</h1>
         <a class="btn btn-success ml-4 mb-3" href="/static/create_certificate.html">Create certificate</a>